package com.fr.plugin.ajhdf.operate;

import com.fr.general.ReportDeclareRecordType;
import com.fr.io.collection.ExportCollection;
import com.fr.plugin.ajhdf.export.PDFExporterPlus;
import com.fr.stable.web.SessionProvider;
import com.fr.web.core.reserve.DefaultOperate;
import com.fr.web.core.utils.ExportUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class CustomPDFOperate extends DefaultOperate {

    /**
     * 返回一个带有PDFExporterPlus导出的ExportCollection
     *
     * @param req
     * @param res
     * @param sessionProvider
     * @param fileName
     * @return
     */
    @Override
    public ExportCollection newExportCollection(HttpServletRequest req, HttpServletResponse res, SessionProvider sessionProvider, String fileName) {
        ExportCollection exportCollection = ExportCollection.create();
        exportCollection.setExporter(new PDFExporterPlus());
        exportCollection.setRecordType(ReportDeclareRecordType.EXPORT_TYPE_PDF);
        this.setContent(req, res, fileName, false);
        return exportCollection;
    }

    /**
     * 设置响应的类型，设置文件名等
     *
     * @param req
     * @param res
     * @param fileName
     * @param isEmbed
     */
    @Override
    public void setContent(HttpServletRequest req, HttpServletResponse res, String fileName, boolean isEmbed) {
        ExportUtils.setPDFContent(res, fileName, isEmbed);
    }
}
